# 2009-10-17 Krzysztof Kaminski OA UAM

procedure red6 ()

  string obj_mask      {"V440Per*", prompt="Object file name mask"}
  string templ_fl      {"rad_vel_std", prompt="Object template file name"}
  string tell_fl       {"tell_vel_std", prompt="Telluric template file name"}
  string output_file   {"fxcor_res", prompt="File name of fxcor std output"}
  bool of_delete       {yes, prompt="Delete previous fxcor std output file?"}
  string rang_obj      {"wide", prompt="Obj. wav. range: manual, wide, medium, narrow"}
  string w_range       {"4500-6800", prompt="Manual obj. wavelength range"}
  string rang_tell     {"tell_strong", prompt="Tell. wav. range: tell_strong, tell_blue, tell_all"}
  bool tell_cor        {"no", prompt="Toggle automatic rv correction with telluric lines?"}
  bool ph_files        {yes, prompt="Create phases.txt file?"}
  bool ph_delete       {yes, prompt="Delete previous phases.txt file?"}
  real HJD0            {0.0, prompt="HJD of phase=0"}
  real Period          {1.0, prompt="Period in days"}
  string rv_name       {"rv", prompt="File name with output radial velocities"}
  string rv_type       {"heliocentric", prompt="Save rv type: heliocentric, relative"}
  bool rv_txt          {yes, prompt="Create <rv_name>.txt file?"}
  bool rv_del          {yes, prompt="Delete previous <rv_name>.txt file?"}
  bool rv_swap         {yes, prompt="Auto-swap rv1 and rv2 (for binaries)?"}
  bool rv_agr          {yes, prompt="Create <rv_name>.agr file?"}
  bool rv_ps           {yes, prompt="Create <rv_name>.ps file?"}
  string rv_plot       {"phase", prompt="Plot rv(phase) or rv(HJD): phase, HJD, both"}
  real ph_range        {1.0, prompt="Phase range to plot: 1.0 or 2.0"}
  string rv_title      {"RV curve", prompt="Plot title"}
  bool rv_inter        {yes, prompt="Interactive fxcor?"}

begin

  string w_range_old
  string ph_file
  ph_file="phases.txt"

  w_range_old=w_range
  if(rang_obj=="wide")
  {
    w_range="4600-5010, 5110-5670, 5770-5860, 6030-6260, 6360-6430, 6620-6850, 7440-7580, 7720-7750, 8660-8810"
  }
  if(rang_obj=="medium")
  {
    w_range="4600-5010, 5110-5670, 5770-5860, 6030-6260, 6360-6430, 6620-6850"
  }
  if(rang_obj=="narrow")
  {
    w_range="4800-5010, 5110-5670, 5770-5860, 6030-6260, 6360-6430, 6620-6850"
  }
  if(rang_obj=="tell_strong")
  {
    w_range="5865-5981, 6265-6327, 6455-6589, 6861-7401, 7588-7706, 7861-8424, 8922-9201"
  }
  if(rang_obj=="tell_blue")
  {
    w_range="5865-5981, 6265-6327, 6455-6589, 6861-7401, 7588-7706"
  }
  if(rang_obj=="tell_all")
  {
    w_range="5020-5105, 5680-5760, 5865-6020, 6265-6327, 6335-6355, 6450-6600, 6861-7430, 7588-7715, 7760-7795, 7860-8650, 8820-9200"
  }

#  noao
#  imred
#  ccdred
#  ccdlist ("@list_obj_cnt.txt", ccdtype="", names=no, long=no, ccdproc="")

#  list="list_obj_cnt.txt"

#  noao
#  onedspec
#  splot(images=list, line=1, band=1, units="", options="auto wreset",
#    xmin=INDEF, xmax=INDEF, ymin=INDEF, ymax=INDEF, save_fi="splot.log",
#    overwri=yes, new_imag="")

#  print ("Type full object name")
#  obj_name=
#  print(obj_name)

  print ("** Selecting spectra of the object **")
  print ("(the list is saved in file: list_obj_red6.txt)")

  system.delete("list_obj_red6.txt")

  system.directory(obj_mask, long=no, ncols=1, maxch=50, sort=no, all=no, >> "list_obj_red6.txt")
#  system.directory(obj_mask, long=no, ncols=1, maxch=50, sort=no, all=no)

#  #tworzenie listy plikow
#  list="list_tmp_red6.txt"
#  i=0
#  while (fscan (list,s1) != EOF)
#  {
#    imgets(image=s1,param="i_title") #wczytanie nazwy obiektu
#    s2=imgets.value
#    i=i+1
#    print(s1, >> "list_obj_red6.txt")
#    print(str(i),":  ",s1,"  ",s2)
#  }

  # tworzenie pliku z fazami
  if(ph_files==yes)
  {
    print ("** Calculating phases **")
    list="list_obj_red6.txt"
    if(ph_delete==yes) system.delete(ph_file)
    printf("#Ephemeris:   HJD0=%.8f   Period=%.10f\n", HJD0, Period, >> ph_file)
    printf("#           file name                 HJD               phase       HA (hours)\n", >> ph_file)
    while (fscan (list,s1) != EOF)
    {
      imgets(image=s1,param="HJD")
      x=real(imgets.value)
      y=frac((x-HJD0)/Period)
      if(y<0.0) y=y+1.0
      imgets(image=s1,param="HA")
      z=real(imgets.value)
      printf("%32.32s %18.6f  %10.6f %10.6f\n",s1,x,y,z, >> ph_file)
    }
  }

  print ("** Cross-corelation **")

  print ("(type 'q' to open next spectrum, type 'ctrl+c' to quit)")
  print ("(use 'g'+'g' to mark fit limits)")
  print ("(for deblending: use 'd'+'d' to set background level,")
  print ("pres 'm' at every peak, choose fit mode (f-full))")

  if(of_delete==yes)
  {
    s3=output_file+".txt"
    system.delete(s3)
    s3=output_file+".log"
    system.delete(s3)
    s3=output_file+".gki"
    system.delete(s3)
  }

#  noao
#  rv
#  continpars.c_interactive = no
#  continpars.c_sample = "*"
#  continpars.c_function = "legendre"
#  continpars.naverage = 1
#  continpars.order = 1
#  continpars.replace = no
#  continpars.low_reject = 2.
#  continpars.high_reject = 4.
#  continpars.niterate = 10
#  continpars.grow = 1.
#  continpars.mode = "ql"

#  noao
#  rv
#  keywpars.ra = "RA"
#  keywpars.dec = "DEC"
#  keywpars.ut = "DATE-OBS"
#  keywpars.utmiddl = ""
#  keywpars.exptime = "EXPTIME"
#  keywpars.epoch = "EPOCH"
#  keywpars.date_ob = "DATE-OBS"
#  keywpars.hjd = "HJD"
#  keywpars.mjd_obs = "MJD"
#  keywpars.vobs = "VOBS"
#  keywpars.vrel = "VREL"
#  keywpars.vhelio = "VHELIO"
#  keywpars.vlsr = "VLSR"
#  keywpars.vsun = "VSUN"

  list="list_obj_red6.txt"
  while (fscan (list,s1) != EOF)
  {
    printf(" Cross-corelating file: %s\n",s1)
    noao
    rv
    fxcor(objects=s1, templates=templ_fl, apertures="*",
      cursor="", continuum="both", filter="none", rebin="smallest",
      pixcorr=no, osample=w_range, rsample=w_range, apodize=0.2,
      function="gaussian", width=INDEF, height=0., peak=no, minwidth=37.,
      maxwidth=39., weights=1., background=INDEF, window=200., wincenter=0.,
      output=output_file, verbose="long", imupdate=no, graphics="stdgraph",
      interactive=rv_inter, autowrite=yes, autodraw=yes, ccftype="image",
      observatory="kpno", continpars="", filtpars="", keywpars="")  #<-- the observatory parameter
                                                                    #is overrided by OBSERVAT fits
                                                                    #header keyword
  }

  if(tell_cor==yes)
  {
  print ("** Telluric lines cross-corelation **")

  print ("(type 'n' to open next spectrum, type 'q' to quit)")

  if(of_delete==yes)
  {
    s3=output_file+"_tell.txt"
    system.delete(s3)
    s3=output_file+"_tell.log"
    system.delete(s3)
    s3=output_file+"_tell.gki"
    system.delete(s3)
  }

#  noao
#  rv
#  continpars.c_interactive = no
#  continpars.c_sample = "*"
#  continpars.c_function = "legendre"
#  continpars.naverage = 1
#  continpars.order = 1
#  continpars.replace = no
#  continpars.low_reject = 2.
#  continpars.high_reject = 4.
#  continpars.niterate = 10
#  continpars.grow = 1.
#  continpars.mode = "ql"

  if(rang_tell=="wide")
  {
    w_range="4600-5010, 5110-5670, 5770-5860, 6030-6260, 6360-6430, 6620-6850, 7440-7580, 7720-7750, 8660-8810"
  }
  if(rang_tell=="medium")
  {
    w_range="4600-5010, 5110-5670, 5770-5860, 6030-6260, 6360-6430, 6620-6850"
  }
  if(rang_tell=="narrow")
  {
    w_range="4800-5010, 5110-5670, 5770-5860, 6030-6260, 6360-6430, 6620-6850"
  }
  if(rang_tell=="tell_strong")
  {
    w_range="5865-5981, 6265-6327, 6455-6589, 6861-7401, 7588-7706, 7861-8424, 8922-9201"
  }
  if(rang_tell=="tell_blue")
  {
    w_range="5865-5981, 6265-6327, 6455-6589, 6861-7401, 7588-7706"
  }
  if(rang_tell=="tell_all")
  {
    w_range="5020-5105, 5680-5760, 5865-6020, 6265-6327, 6335-6355, 6450-6600, 6861-7430, 7588-7715, 7760-7795, 7860-8650, 8820-9200"
  }

  s3=output_file+"_tell"

  noao
  rv
  fxcor(objects="@list_obj_red6.txt", templates=tell_fl, apertures="*",
    cursor="", continuum="both", filter="none", rebin="smallest",
    pixcorr=no, osample=w_range, rsample=w_range, apodize=0.2,
    function="gaussian", width=INDEF, height=0, peak=no, minwidth=17.,
    maxwidth=19., weights=1., background=INDEF, window=100., wincenter=INDEF,
    output=s3, verbose="long", imupdate=no, graphics="stdgraph",
    interactive=rv_inter, autowrite=yes, autodraw=yes, ccftype="image",
    observatory="kpno", continpars="", filtpars="", keywpars="")  #<-- the observatory parameter
                                                                  #is overrided by OBSERVAT fits
                                                                  #header keyword
  }

  w_range=w_range_old

  #calculate txt output file with nice table and ps and agr plots

  if((rv_txt==yes)&&(rv_del==yes))
  {
    s3=rv_name+".txt"
    system.delete(s3)
    s3=rv_name+"_tell.txt"
    system.delete(s3)
    s3=rv_name+"_t.txt"
    system.delete(s3)
  }

  if(ph_files==yes)
  {
    if((rv_txt==yes)||(rv_agr==yes)||(rv_ps==yes))
    {
    print ("** Creating rv table & plots **")
    system.delete("red6.py.cmd")
    print (output_file, >> "red6.py.cmd")
    print (rv_txt, >> "red6.py.cmd")
    print (rv_agr, >> "red6.py.cmd")
    print (rv_ps, >> "red6.py.cmd")
    print (rv_name, >> "red6.py.cmd")
    print (ph_range, >> "red6.py.cmd")
    print (rv_swap, >> "red6.py.cmd")
    print (rv_plot, >> "red6.py.cmd")
    print (HJD0, >> "red6.py.cmd")
    print (Period, >> "red6.py.cmd")
    print (rv_title, >> "red6.py.cmd")
    print (tell_cor, >> "red6.py.cmd")
    print (rv_type, >> "red6.py.cmd")
    !./red6.py
    system.delete("red6.py.cmd")
    }
  }

  system.delete("list_obj_red6.txt")

  print ("Finish")
end
